// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlGraphColumn")]
    pub struct GraphColumn(Object<ffi::DzlGraphColumn, ffi::DzlGraphColumnClass>);

    match fn {
        type_ => || ffi::dzl_graph_view_column_get_type(),
    }
}

impl GraphColumn {
    #[doc(alias = "dzl_graph_view_column_new")]
    pub fn new(name: &str, value_type: glib::types::Type) -> GraphColumn {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_full(ffi::dzl_graph_view_column_new(
                name.to_glib_none().0,
                value_type.into_glib(),
            ))
        }
    }

    #[doc(alias = "dzl_graph_view_column_get_name")]
    #[doc(alias = "get_name")]
    pub fn name(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::dzl_graph_view_column_get_name(self.to_glib_none().0)) }
    }

    #[doc(alias = "dzl_graph_view_column_set_name")]
    pub fn set_name(&self, name: &str) {
        unsafe {
            ffi::dzl_graph_view_column_set_name(self.to_glib_none().0, name.to_glib_none().0);
        }
    }

    #[doc(alias = "value-type")]
    pub fn value_type(&self) -> glib::types::Type {
        ObjectExt::property(self, "value-type")
    }

    #[doc(alias = "name")]
    pub fn connect_name_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_name_trampoline<F: Fn(&GraphColumn) + 'static>(
            this: *mut ffi::DzlGraphColumn,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::name\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_name_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl fmt::Display for GraphColumn {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("GraphColumn")
    }
}
